import React from "react";
import type { RouteProps } from "react-router";
import { ParamsValidation } from "./validations";
import type { RouteHOCProps, Params, RouteLink } from "./types";
export declare function Route<Props>(WrappedComponent: React.FC<Props & RouteHOCProps>): React.FC<Props & RouteProps>;
export declare namespace Route {
    var params: ParamsValidation<never>;
}
export declare function Route<Path extends string>(path: Path): <Props>(WrappedComponent: React.FC<Props & RouteHOCProps<Path>>) => React.FC<Props & RouteProps> & {
    link: RouteLink<Path>;
};
export declare namespace Route {
    var params: ParamsValidation<never>;
}
export declare function Route<Validation extends {
    [x: string]: ParamsValidation<any>;
}, Path extends (values: Params<Validation>) => string>(validation: Validation, path: Path): <Props>(WrappedComponent: React.FC<Props & RouteHOCProps<ReturnType<Path>, Params<Validation>>>) => React.FC<Props & RouteProps> & {
    link: RouteLink<ReturnType<Path>, Params<Validation>>;
};
export declare namespace Route {
    var params: ParamsValidation<never>;
}
